/*

    This file is a part of the GLAMMAR source distribution 
    and therefore subjected to the copy notice below. 
    
    Copyright (C) 1989,1990  Eric Voss, ericv@cs.kun.nl 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 1

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "ge1.h"
#ifdef UREALTOINT 
void urealtoint () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( drealtoint (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = urealtoint; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UDECIMALTOUN 
void udecimaltounary () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( ddecimaltounary (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = udecimaltounary; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UUPPERCASE 
void uuppercase () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( duppercase (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = uuppercase; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef ULOWERCASE 
void ulowercase () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( dlowercase (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = ulowercase; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UKEYWORD 
void ukeyword () 
{ 
   register cont *rq = q;
register AFFIX A_0 = rq->a;
   char *rc = c; 
   if ( dkeyword (A_0)) {
      q = rq -2;
      (*(rq -1)->q)(); 
      rq = q +1;
   }
   rq->a = A_0;
   (rq + 1)->q = ukeyword; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UTYPEOUT 
void utypeout () 
{ 
   register cont *rq = q;
register AFFIX A_0 = rq->a;
   char *rc = c; 
   if ( dtypeout (A_0)) {
      q = rq -2;
      (*(rq -1)->q)(); 
      rq = q +1;
   }
   rq->a = A_0;
   (rq + 1)->q = utypeout; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
   q = rq + 1; 
}
#endif

#ifdef UTYPEIN 
void utypein () 
{ 
   register cont *rq = q;
register AFFIX A_0 = rq->a;
   char *rc = c; 
   if ( dtypein (A_0)) {
      q = rq -2;
      (*(rq -1)->q)(); 
      rq = q +1;
   }
   rq->a = A_0;
   (rq + 1)->q = utypein; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
   q = rq + 1; 
}
#endif
